import os
from tqdm import tqdm #contador

fileName = "selzebra.blast"
fileLength = "/mnt/NFS_UPF/soft/genomes/2021/Atractosteus_spatula/genome.lengths"
library = {} #diccionari1
lengths = {} #diccionari3

with open(fileLength) as file: 
	for line in file:
		line = line.strip()	
		columnes=line.split()
		lengths[columnes[1]] = int(columnes[0])

with open(fileName) as file:
	for line in file:
		line = line.strip()
		if "#" in line:
			pass
		else:
			columnes=line.split()
			if float(columnes[10]) < 1e-5:
				if columnes[0] not in library:
					library[columnes[0]] = {} #diccionari2

				if columnes[1] not in library[columnes[0]]:
					diferencia = int(columnes[9]) - int(columnes[8])
					if diferencia < 0:
						library[columnes[0]][columnes[1]] = columnes[9]
					else:
						library[columnes[0]][columnes[1]] = columnes[8]

#proteins = ["SPP00000645_2.0_SelR1"]
outfileTable = open("table.results.txt","w")
for protein in tqdm(library):
	cmd = "mkdir "+protein
	os.system(cmd)
	for scaf in library[protein]:
		cmd = "mkdir "+protein+"/"+scaf
		os.system(cmd)
		
		iniciscaf = library[protein][scaf]
		cmd = "fastafetch /mnt/NFS_UPF/soft/genomes/2021/Atractosteus_spatula/genome.fa /mnt/NFS_UPF/soft/genomes/2021/Atractosteus_spatula/genome.index "+scaf+" > "+protein+"/"+scaf+"/contig.fetch.fa"
		os.system(cmd)
		
		inicicontig = int(iniciscaf) - 50000
		afegit = 50000
		if inicicontig < 0:
			afegit = int(iniciscaf)
			inicicontig = 0
			print("Changed startcontig",scaf)
		
		finalcontig = inicicontig + 100000
		if finalcontig > lengths[scaf]:
			afegit = afegit + lengths[scaf] - int(iniciscaf)
			print("Changed endcontig",scaf)
		else:
			afegit = afegit + 50000
	
			
		cmd = "fastasubseq "+protein+"/"+scaf+"/contig.fetch.fa " +str(inicicontig)+" "+str(afegit)+" > "+protein+"/"+scaf+"/genomic.fa"
		os.system(cmd)
				
		cmd = "exonerate -m p2g --showtargetgff -q original_proteins/"+protein+".fa-1 -t "+protein+"/"+scaf+"/genomic.fa | egrep -w exon > "+protein+"/"+scaf+"/"+protein+".gff"
		os.system(cmd)
		
		with open(protein+"/"+scaf+"/"+protein+".gff") as file: 
			for line in file:
				line = line.strip()	
				columnes=line.split()
				start = int(columnes[3]) + inicicontig
				stop = int(columnes[4]) + inicicontig
				frame = columnes[6]
				print(protein+"\t"+scaf+"\t"+str(start)+"\t"+str(stop)+"\t"+frame,file=outfileTable)
		
		cmd = "fastaseqfromGFF.pl "+protein+"/"+scaf+"/genomic.fa "+protein+"/"+scaf+"/"+protein+".gff > "+protein+"/"+scaf+"/"+protein+"pred.nuc"
		os.system(cmd)
		
		cmd = "fastatranslate -f "+protein+"/"+scaf+"/"+protein+"pred.nuc -F 1 > "+protein+"/"+scaf+"/"+protein+"pred.fa"
		os.system(cmd)

		outfile = open(protein+"/"+scaf+"/"+protein+"predX.fa","w")		
		for line in open(protein+"/"+scaf+"/"+protein+"pred.fa"):
			line = line.strip()
			if ">" not in line:
				line = line.replace("*","X")
			print(line,file=outfile)
		outfile.close()
		
		cmd = "t_coffee original_proteins/"+protein+".fa-1 "+protein+"/"+scaf+"/"+protein+"predX.fa 1> "+protein+"/"+scaf+"/"+protein+".align 2>log"
		os.system(cmd)
		
outfileTable.close()
		
		
